Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkXRenderWindowInteractor Class Reference

`#include <vtkXRenderWindowInteractor.h>`

Inheritance diagram for vtkXRenderWindowInteractor:

[legend]
Collaboration diagram for vtkXRenderWindowInteractor:

[legend]
List of all members.

## Detailed Description

an X event driven interface for a RenderWindow

Date:
  2002/11/22 16:25:58

Revision:
  1.66

vtkXRenderWindowInteractor is a convenience object that provides event bindings to common graphics functions. For example, camera and actor functions such as zoom-in/zoom-out, azimuth, roll, and pan. IT is one of the window system specific subclasses of vtkRenderWindowInteractor. Please see vtkRenderWindowInteractor documentation for event bindings.

See also:
  vtkRenderWindowInteractor vtkXRenderWindow

I've been though this and deleted all I think should go, tried to create the basic structure and if you're lucky it might even work! but frankly I doubt it

Events:
  vtkCommand::LeftButtonReleaseEvent vtkCommand::RightButtonPressEvent vtkCommand::MouseMoveEvent vtkCommand::MiddleButtonReleaseEvent vtkCommand::ExposeEvent vtkCommand::EnterEvent vtkCommand::StartEvent vtkCommand::TimerEvent vtkCommand::KeyPressEvent vtkCommand::RightButtonReleaseEvent vtkCommand::ConfigureEvent vtkCommand::MiddleButtonPressEvent vtkCommand::CharEvent vtkCommand::LeaveEvent vtkCommand::LeftButtonPressEvent vtkCommand::KeyReleaseEvent

Created by:
  - Martin, Ken

CVS contributions (if > 5%):
  - Martin, Ken (42%)
  - Pan, Tony (27%)
  - Gobbi, David (6%)
  - Schroeder, Will (5%)

CVS logs (CVSweb):
  - .`cxx` (`/Rendering/vtkXRenderWindowInteractor.cxx)`
  - .`h` (`/Rendering/vtkXRenderWindowInteractor.h)`

Examples:
  vtkXRenderWindowInteractor (Examples)

Definition at line 67 of file vtkXRenderWindowInteractor.h.

## Public Types
typedef vtkRenderWindowInteractor | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
virtual void | Initialize ()
void | TerminateApp (void)
virtual void | Start ()
virtual void | GetMousePosition (int *x, int *y)
virtual void | SetBreakLoopFlag (int)
virtual int | GetBreakLoopFlag ()
virtual void | BreakLoopFlagOn ()
virtual void | BreakLoopFlagOff ()
int | CreateTimer (int timertype)
int | DestroyTimer (void)
virtual void | Initialize (XtAppContext app)
virtual XtAppContext | GetApp ()
virtual void | Enable ()
virtual void | Disable ()
virtual void | SetWidget (Widget)
Widget | GetWidget ()
virtual void | SetTopLevelShell (Widget)
Widget | GetTopLevelShell ()
## Static Public Methods
vtkXRenderWindowInteractor * | New ()
int | IsTypeOf (const char *type)
vtkXRenderWindowInteractor * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkXRenderWindowInteractor ()
| ~vtkXRenderWindowInteractor ()
XtIntervalId | AddTimeOut (XtAppContext app_context, unsigned long interval, XtTimerCallbackProc proc, XtPointer client_data)
void | Timer (XtPointer client_data, XtIntervalId *id)
void | Callback (Widget w, XtPointer client_data, XEvent *event, Boolean *ctd)
## Static Protected Methods
void | BreakXtLoop (vtkObject *, unsigned long, void *, void *)
## Protected Attributes
Display * | DisplayId
Window | WindowId
Widget | Top
int | OwnTop
XtAppContext | App
int | PositionBeforeStereo [2]
Widget | TopLevelShell
int | BreakLoopFlag
vtkCallbackCommand * | BreakXtLoopCallback
## Friends
void | vtkXRenderWindowInteractorCallback (Widget, XtPointer, XEvent *, Boolean *)
void | vtkXRenderWindowInteractorTimer (XtPointer, XtIntervalId *)

## Member Typedef Documentation

typedef vtkRenderWindowInteractor vtkXRenderWindowInteractor::Superclass

| Reimplemented from vtkRenderWindowInteractor. Definition at line 71 of file vtkXRenderWindowInteractor.h.

## Constructor & Destructor Documentation

vtkXRenderWindowInteractor::vtkXRenderWindowInteractor | ( |  | ) | `[protected]`

vtkXRenderWindowInteractor::~vtkXRenderWindowInteractor | ( |  | ) | `[protected]`

## Member Function Documentation

vtkXRenderWindowInteractor* vtkXRenderWindowInteractor::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkRenderWindowInteractor.

virtual const char* vtkXRenderWindowInteractor::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkRenderWindowInteractor.

int vtkXRenderWindowInteractor::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkRenderWindowInteractor.

virtual int vtkXRenderWindowInteractor::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkRenderWindowInteractor.

vtkXRenderWindowInteractor* vtkXRenderWindowInteractor::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkRenderWindowInteractor.

void vtkXRenderWindowInteractor::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkRenderWindowInteractor.

virtual void vtkXRenderWindowInteractor::Initialize | ( |  | ) | `[virtual]`

| Initializes the event handlers without an XtAppContext. This is good for when you don't have a user interface, but you still want to have mouse interaction. Reimplemented from vtkRenderWindowInteractor.

void vtkXRenderWindowInteractor::TerminateApp | ( | void |  | ) | `[inline, virtual]`

| Call exit on 'q','e' keypress. Want more ??? Reimplemented from vtkRenderWindowInteractor. Definition at line 80 of file vtkXRenderWindowInteractor.h.

virtual void vtkXRenderWindowInteractor::SetBreakLoopFlag | ( | int |  | ) | `[virtual]`

| The BreakLoopFlag is checked in the Start() method. Setting it to anything other than zero will cause the interactor loop to terminate and return to the calling function.

virtual int vtkXRenderWindowInteractor::GetBreakLoopFlag | ( |  | ) | `[virtual]`

| The BreakLoopFlag is checked in the Start() method. Setting it to anything other than zero will cause the interactor loop to terminate and return to the calling function.

virtual void vtkXRenderWindowInteractor::BreakLoopFlagOn | ( |  | ) | `[virtual]`

| The BreakLoopFlag is checked in the Start() method. Setting it to anything other than zero will cause the interactor loop to terminate and return to the calling function.

virtual void vtkXRenderWindowInteractor::BreakLoopFlagOff | ( |  | ) | `[virtual]`

| The BreakLoopFlag is checked in the Start() method. Setting it to anything other than zero will cause the interactor loop to terminate and return to the calling function.

int vtkXRenderWindowInteractor::CreateTimer | ( | int | timertype | ) | `[virtual]`

| X timer methods Reimplemented from vtkRenderWindowInteractor.

int vtkXRenderWindowInteractor::DestroyTimer | ( | void |  | ) | `[virtual]`

| X timer methods Reimplemented from vtkRenderWindowInteractor.

virtual void vtkXRenderWindowInteractor::Initialize | ( | XtAppContext | app | ) | `[virtual]`

| Initializes the event handlers using an XtAppContext that you have provided. This assumes that you want to own the event loop.

virtual XtAppContext vtkXRenderWindowInteractor::GetApp | ( |  | ) | `[virtual]`

| Initializes the event handlers using an XtAppContext that you have provided. This assumes that you want to own the event loop.

virtual void vtkXRenderWindowInteractor::Enable | ( |  | ) | `[virtual]`

| Enable/Disable interactions. By default interactors are enabled when initialized. Initialize() must be called prior to enabling/disabling interaction. These methods are used when a window/widget is being shared by multiple renderers and interactors. This allows a "modal" display where one interactor is active when its data is to be displayed and all other interactors associated with the widget are disabled when their data is not displayed. Reimplemented from vtkRenderWindowInteractor.

virtual void vtkXRenderWindowInteractor::Disable | ( |  | ) | `[virtual]`

| Enable/Disable interactions. By default interactors are enabled when initialized. Initialize() must be called prior to enabling/disabling interaction. These methods are used when a window/widget is being shared by multiple renderers and interactors. This allows a "modal" display where one interactor is active when its data is to be displayed and all other interactors associated with the widget are disabled when their data is not displayed. Reimplemented from vtkRenderWindowInteractor.

virtual void vtkXRenderWindowInteractor::Start | ( |  | ) | `[virtual]`

| This will start up the X event loop and never return. If you call this method it will loop processing X events until the application is exited. Reimplemented from vtkRenderWindowInteractor.

virtual void vtkXRenderWindowInteractor::SetWidget | ( | Widget |  | ) | `[virtual]`

| Specify the Xt widget to use for interaction. This method is one of a couple steps that are required for setting up a vtkRenderWindowInteractor as a widget inside of another user interface. You do not need to use this method if the render window will be a stand-alone window. This is only used when you want the render window to be a subwindow within a larger user interface. In that case, you must tell the render window what X display id to use, and then ask the render window what depth, visual and colormap it wants. Then, you must create an Xt TopLevelShell with those settings. Then you can create the rest of your user interface as a child of the TopLevelShell you created. Eventually, you will create a drawing area or some other widget to serve as the rendering window. You must use the SetWidget method to tell this Interactor about that widget. It's X and it's not terribly easy, but it looks cool.

Widget vtkXRenderWindowInteractor::GetWidget | ( |  | ) | `[inline]`

| Specify the Xt widget to use for interaction. This method is one of a couple steps that are required for setting up a vtkRenderWindowInteractor as a widget inside of another user interface. You do not need to use this method if the render window will be a stand-alone window. This is only used when you want the render window to be a subwindow within a larger user interface. In that case, you must tell the render window what X display id to use, and then ask the render window what depth, visual and colormap it wants. Then, you must create an Xt TopLevelShell with those settings. Then you can create the rest of your user interface as a child of the TopLevelShell you created. Eventually, you will create a drawing area or some other widget to serve as the rendering window. You must use the SetWidget method to tell this Interactor about that widget. It's X and it's not terribly easy, but it looks cool. Definition at line 137 of file vtkXRenderWindowInteractor.h.

virtual void vtkXRenderWindowInteractor::SetTopLevelShell | ( | Widget |  | ) | `[virtual]`

| This method will store the top level shell widget for the interactor. This method and the method invocation sequence applies for: 1 vtkRenderWindow-Interactor pair in a nested widget hierarchy multiple vtkRenderWindow-Interactor pairs in the same top level shell It is not needed for 1 vtkRenderWindow-Interactor pair as the direct child of a top level shell multiple vtkRenderWindow-Interactor pairs, each in its own top level shell The method, along with EnterNotify event, changes the keyboard focus among the widgets/vtkRenderWindow(s) so the Interactor(s) can receive the proper keyboard events. The following calls need to be made: vtkRenderWindow's display ID need to be set to the top level shell's display ID. vtkXRenderWindowInteractor's Widget has to be set to the vtkRenderWindow's container widget vtkXRenderWindowInteractor's TopLevel has to be set to the top level shell widget note that the procedure for setting up render window in a widget needs to be followed. See vtkRenderWindowInteractor's SetWidget method. If multiple vtkRenderWindow-Interactor pairs in SEPARATE windows are desired, do not set the display ID (Interactor will create them as needed. Alternatively, create and set distinct DisplayID for each vtkRenderWindow. Using the same display ID without setting the parent widgets will cause the display to be reinitialized every time an interactor is initialized), do not set the widgets (so the render windows would be in their own windows), and do not set TopLevelShell (each has its own top level shell already)

Widget vtkXRenderWindowInteractor::GetTopLevelShell | ( |  | ) | `[inline]`

| This method will store the top level shell widget for the interactor. This method and the method invocation sequence applies for: 1 vtkRenderWindow-Interactor pair in a nested widget hierarchy multiple vtkRenderWindow-Interactor pairs in the same top level shell It is not needed for 1 vtkRenderWindow-Interactor pair as the direct child of a top level shell multiple vtkRenderWindow-Interactor pairs, each in its own top level shell The method, along with EnterNotify event, changes the keyboard focus among the widgets/vtkRenderWindow(s) so the Interactor(s) can receive the proper keyboard events. The following calls need to be made: vtkRenderWindow's display ID need to be set to the top level shell's display ID. vtkXRenderWindowInteractor's Widget has to be set to the vtkRenderWindow's container widget vtkXRenderWindowInteractor's TopLevel has to be set to the top level shell widget note that the procedure for setting up render window in a widget needs to be followed. See vtkRenderWindowInteractor's SetWidget method. If multiple vtkRenderWindow-Interactor pairs in SEPARATE windows are desired, do not set the display ID (Interactor will create them as needed. Alternatively, create and set distinct DisplayID for each vtkRenderWindow. Using the same display ID without setting the parent widgets will cause the display to be reinitialized every time an interactor is initialized), do not set the widgets (so the render windows would be in their own windows), and do not set TopLevelShell (each has its own top level shell already) Definition at line 166 of file vtkXRenderWindowInteractor.h.

virtual void vtkXRenderWindowInteractor::GetMousePosition | ( | int * | x,
|  | int * | y
| ) | `[virtual]`

| Re-defines virtual function to get mouse position by querying X-server. Reimplemented from vtkRenderWindowInteractor.

XtIntervalId vtkXRenderWindowInteractor::AddTimeOut | ( | XtAppContext | app_context,
|  | unsigned long | interval,
|  | XtTimerCallbackProc | proc,
|  | XtPointer | client_data
| ) | `[protected]`

void vtkXRenderWindowInteractor::Timer | ( | XtPointer | client_data,
|  | XtIntervalId * | id
| ) | `[protected]`

void vtkXRenderWindowInteractor::Callback | ( | Widget | w,
|  | XtPointer | client_data,
|  | XEvent * | event,
|  | Boolean * | ctd
| ) | `[protected]`

void vtkXRenderWindowInteractor::BreakXtLoop | ( | vtkObject * | ,
|  | unsigned | long,
|  | void * | ,
|  | void * |
| ) | `[static, protected]`

## Friends And Related Function Documentation

void vtkXRenderWindowInteractorCallback | ( | Widget | ,
|  | XtPointer | ,
|  | XEvent * | ,
|  | Boolean * |
| ) | `[friend]`

| Functions that are used internally.

void vtkXRenderWindowInteractorTimer | ( | XtPointer | ,
|  | XtIntervalId * |
| ) | `[friend]`

| Functions that are used internally.

## Member Data Documentation

Display* vtkXRenderWindowInteractor::DisplayId`[protected]`

| Definition at line 184 of file vtkXRenderWindowInteractor.h.

Window vtkXRenderWindowInteractor::WindowId`[protected]`

| Definition at line 185 of file vtkXRenderWindowInteractor.h.

Widget vtkXRenderWindowInteractor::Top`[protected]`

| Definition at line 186 of file vtkXRenderWindowInteractor.h.

int vtkXRenderWindowInteractor::OwnTop`[protected]`

| Definition at line 187 of file vtkXRenderWindowInteractor.h.

XtAppContext vtkXRenderWindowInteractor::App`[protected]`

| Definition at line 188 of file vtkXRenderWindowInteractor.h.

int vtkXRenderWindowInteractor::PositionBeforeStereo[2]`[protected]`

| Definition at line 189 of file vtkXRenderWindowInteractor.h.

Widget vtkXRenderWindowInteractor::TopLevelShell`[protected]`

| Definition at line 190 of file vtkXRenderWindowInteractor.h.

int vtkXRenderWindowInteractor::BreakLoopFlag`[protected]`

| Definition at line 192 of file vtkXRenderWindowInteractor.h.

vtkCallbackCommand* vtkXRenderWindowInteractor::BreakXtLoopCallback`[protected]`

| Definition at line 198 of file vtkXRenderWindowInteractor.h.

The documentation for this class was generated from the following file:

- Rendering/vtkXRenderWindowInteractor.h